"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_get_1 = __importDefault(require("lodash.get"));
var actionTypes_1 = require("../actionTypes");
var INITIAL_STATE = {};
var getEntitiesFromAction = function (action) {
    return Object.keys(lodash_get_1.default(action, 'payload.response.entities', {}));
};
exports.default = (function (collection) { return function (state, action) {
    if (state === void 0) { state = INITIAL_STATE; }
    var collectionType = lodash_get_1.default(action, 'payload.collection');
    var isSameCollection = collection === collectionType;
    var isInEntities = getEntitiesFromAction(action).some(function (entity) { return entity === collection; });
    if (isSameCollection || isInEntities) {
        return reducer(state, __assign(__assign({}, action), { payload: __assign(__assign({}, action.payload), { collection: collection }) }));
    }
    return state;
}; });
var mergeValues = function (obj1, obj2) {
    return Object.keys(obj2).reduce(function (acc, key) {
        var _a;
        return (__assign(__assign({}, acc), (_a = {}, _a[key] = __assign(__assign({}, (acc[key] || {})), obj2[key]), _a)));
    }, obj1);
};
var reducer = function (state, action) {
    if (state === void 0) { state = INITIAL_STATE; }
    if (!action.payload || !action.payload.collection) {
        return state;
    }
    switch (action.type) {
        case actionTypes_1.actionTypes.DELETE_SUCCESS:
            var deletedId_1 = Object.keys(action.payload.response.entities[action.payload.collection])[0];
            return Object.keys(state).reduce(function (prev, curr) {
                var _a;
                if (curr === deletedId_1) {
                    return prev;
                }
                return __assign(__assign({}, prev), (_a = {}, _a[curr] = __assign({}, state[curr]), _a));
            }, {});
        case actionTypes_1.actionTypes.CREATE_SUCCESS:
        case actionTypes_1.actionTypes.FETCH_SUCCESS:
        case actionTypes_1.actionTypes.UPDATE_SUCCESS:
            var entities = (action.payload.response.entities &&
                action.payload.response.entities[action.payload.collection]) ||
                {};
            return mergeValues(state, entities);
        default:
            return state;
    }
};
//# sourceMappingURL=entities.js.map