"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var actionTypes_1 = require("../actionTypes");
var types_1 = require("../types");
var INITIAL_STATE = {
    error: undefined,
    deleteStatus: types_1.RequestStatus.NOT_STARTED,
    fetchStatus: types_1.RequestStatus.NOT_STARTED,
    saveStatus: types_1.RequestStatus.NOT_STARTED,
};
var requestsReducer = function (state, action) {
    if (state === void 0) { state = INITIAL_STATE; }
    switch (action.type) {
        case actionTypes_1.actionTypes.CREATE_REQUEST:
        case actionTypes_1.actionTypes.UPDATE_REQUEST:
            return __assign(__assign({}, state), { error: undefined, saveStatus: types_1.RequestStatus.STARTED });
        case actionTypes_1.actionTypes.CREATE_SUCCESS:
        case actionTypes_1.actionTypes.UPDATE_SUCCESS:
            return __assign(__assign({}, state), { saveStatus: types_1.RequestStatus.DONE });
        case actionTypes_1.actionTypes.CREATE_FAILURE:
        case actionTypes_1.actionTypes.UPDATE_FAILURE:
            return __assign(__assign({}, state), { error: action.payload.error, saveStatus: types_1.RequestStatus.ERROR });
        case actionTypes_1.actionTypes.DELETE_REQUEST:
            return __assign(__assign({}, state), { error: undefined, deleteStatus: types_1.RequestStatus.STARTED });
        case actionTypes_1.actionTypes.DELETE_SUCCESS:
            return __assign(__assign({}, state), { deleteStatus: types_1.RequestStatus.DONE });
        case actionTypes_1.actionTypes.DELETE_FAILURE:
            return __assign(__assign({}, state), { error: action.payload.error, deleteStatus: types_1.RequestStatus.ERROR });
        case actionTypes_1.actionTypes.FETCH_REQUEST:
            return __assign(__assign({}, state), { error: undefined, fetchStatus: types_1.RequestStatus.STARTED });
        case actionTypes_1.actionTypes.FETCH_SUCCESS:
            return __assign(__assign({}, state), { fetchStatus: types_1.RequestStatus.DONE });
        case actionTypes_1.actionTypes.FETCH_FAILURE:
            return __assign(__assign({}, state), { error: action.payload.error, fetchStatus: types_1.RequestStatus.ERROR });
        case actionTypes_1.actionTypes.RESET_REQUEST: {
            return __assign({}, INITIAL_STATE);
        }
        default:
            return state;
    }
};
exports.default = (function (type) { return function (state, action) {
    if (state === void 0) { state = INITIAL_STATE; }
    var actionType = action.payload && action.payload.type;
    if (actionType !== type) {
        return state;
    }
    return requestsReducer(state, action);
}; });
//# sourceMappingURL=requests.js.map