import { Schema } from 'normalizr';
import { Action } from 'redux';
export interface ApiType {
    collection: string;
    schema: Schema;
}
export interface TypeMap {
    [key: string]: ApiType;
}
export interface ApiOptions {
    data?: any;
    headers?: any;
    method?: string;
    url: string;
}
export interface ActionPayload {
    collection?: string;
    error?: string | number;
    options?: ApiOptions;
    query?: any;
    response?: any;
    schema?: Schema;
    type?: string;
    [key: string]: any;
}
export interface FaniquitoAction extends Action {
    payload?: ActionPayload;
    type: string;
}
export declare enum RequestStatus {
    DONE = "DONE",
    ERROR = "ERROR",
    NOT_STARTED = "NOT_STARTED",
    STARTED = "STARTED"
}
export interface RequestState {
    error?: string;
    deleteStatus: RequestStatus;
    fetchStatus: RequestStatus;
    saveStatus: RequestStatus;
}
